<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - QtCore/qdebug.h</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">QtCore</a> - qdebug.h<span style="font-size: 80%;"> (source / <a href="qdebug.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">3</td>
            <td class="headerCovTableEntryLo">0.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">3</td>
            <td class="headerCovTableEntryLo">0.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : /****************************************************************************</a>
<a name="2"><span class="lineNum">       2 </span>            : **</a>
<a name="3"><span class="lineNum">       3 </span>            : ** Copyright (C) 2016 The Qt Company Ltd.</a>
<a name="4"><span class="lineNum">       4 </span>            : ** Copyright (C) 2016 Intel Corporation.</a>
<a name="5"><span class="lineNum">       5 </span>            : ** Contact: https://www.qt.io/licensing/</a>
<a name="6"><span class="lineNum">       6 </span>            : **</a>
<a name="7"><span class="lineNum">       7 </span>            : ** This file is part of the QtCore module of the Qt Toolkit.</a>
<a name="8"><span class="lineNum">       8 </span>            : **</a>
<a name="9"><span class="lineNum">       9 </span>            : ** $QT_BEGIN_LICENSE:LGPL$</a>
<a name="10"><span class="lineNum">      10 </span>            : ** Commercial License Usage</a>
<a name="11"><span class="lineNum">      11 </span>            : ** Licensees holding valid commercial Qt licenses may use this file in</a>
<a name="12"><span class="lineNum">      12 </span>            : ** accordance with the commercial license agreement provided with the</a>
<a name="13"><span class="lineNum">      13 </span>            : ** Software or, alternatively, in accordance with the terms contained in</a>
<a name="14"><span class="lineNum">      14 </span>            : ** a written agreement between you and The Qt Company. For licensing terms</a>
<a name="15"><span class="lineNum">      15 </span>            : ** and conditions see https://www.qt.io/terms-conditions. For further</a>
<a name="16"><span class="lineNum">      16 </span>            : ** information use the contact form at https://www.qt.io/contact-us.</a>
<a name="17"><span class="lineNum">      17 </span>            : **</a>
<a name="18"><span class="lineNum">      18 </span>            : ** GNU Lesser General Public License Usage</a>
<a name="19"><span class="lineNum">      19 </span>            : ** Alternatively, this file may be used under the terms of the GNU Lesser</a>
<a name="20"><span class="lineNum">      20 </span>            : ** General Public License version 3 as published by the Free Software</a>
<a name="21"><span class="lineNum">      21 </span>            : ** Foundation and appearing in the file LICENSE.LGPL3 included in the</a>
<a name="22"><span class="lineNum">      22 </span>            : ** packaging of this file. Please review the following information to</a>
<a name="23"><span class="lineNum">      23 </span>            : ** ensure the GNU Lesser General Public License version 3 requirements</a>
<a name="24"><span class="lineNum">      24 </span>            : ** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.</a>
<a name="25"><span class="lineNum">      25 </span>            : **</a>
<a name="26"><span class="lineNum">      26 </span>            : ** GNU General Public License Usage</a>
<a name="27"><span class="lineNum">      27 </span>            : ** Alternatively, this file may be used under the terms of the GNU</a>
<a name="28"><span class="lineNum">      28 </span>            : ** General Public License version 2.0 or (at your option) the GNU General</a>
<a name="29"><span class="lineNum">      29 </span>            : ** Public license version 3 or any later version approved by the KDE Free</a>
<a name="30"><span class="lineNum">      30 </span>            : ** Qt Foundation. The licenses are as published by the Free Software</a>
<a name="31"><span class="lineNum">      31 </span>            : ** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3</a>
<a name="32"><span class="lineNum">      32 </span>            : ** included in the packaging of this file. Please review the following</a>
<a name="33"><span class="lineNum">      33 </span>            : ** information to ensure the GNU General Public License requirements will</a>
<a name="34"><span class="lineNum">      34 </span>            : ** be met: https://www.gnu.org/licenses/gpl-2.0.html and</a>
<a name="35"><span class="lineNum">      35 </span>            : ** https://www.gnu.org/licenses/gpl-3.0.html.</a>
<a name="36"><span class="lineNum">      36 </span>            : **</a>
<a name="37"><span class="lineNum">      37 </span>            : ** $QT_END_LICENSE$</a>
<a name="38"><span class="lineNum">      38 </span>            : **</a>
<a name="39"><span class="lineNum">      39 </span>            : ****************************************************************************/</a>
<a name="40"><span class="lineNum">      40 </span>            : </a>
<a name="41"><span class="lineNum">      41 </span>            : #ifndef QDEBUG_H</a>
<a name="42"><span class="lineNum">      42 </span>            : #define QDEBUG_H</a>
<a name="43"><span class="lineNum">      43 </span>            : </a>
<a name="44"><span class="lineNum">      44 </span>            : #include &lt;QtCore/qalgorithms.h&gt;</a>
<a name="45"><span class="lineNum">      45 </span>            : #include &lt;QtCore/qhash.h&gt;</a>
<a name="46"><span class="lineNum">      46 </span>            : #include &lt;QtCore/qlist.h&gt;</a>
<a name="47"><span class="lineNum">      47 </span>            : #include &lt;QtCore/qmap.h&gt;</a>
<a name="48"><span class="lineNum">      48 </span>            : #include &lt;QtCore/qpair.h&gt;</a>
<a name="49"><span class="lineNum">      49 </span>            : #include &lt;QtCore/qtextstream.h&gt;</a>
<a name="50"><span class="lineNum">      50 </span>            : #include &lt;QtCore/qstring.h&gt;</a>
<a name="51"><span class="lineNum">      51 </span>            : #include &lt;QtCore/qvector.h&gt;</a>
<a name="52"><span class="lineNum">      52 </span>            : #include &lt;QtCore/qset.h&gt;</a>
<a name="53"><span class="lineNum">      53 </span>            : #include &lt;QtCore/qcontiguouscache.h&gt;</a>
<a name="54"><span class="lineNum">      54 </span>            : #include &lt;QtCore/qsharedpointer.h&gt;</a>
<a name="55"><span class="lineNum">      55 </span>            : </a>
<a name="56"><span class="lineNum">      56 </span>            : // all these have already been included by various headers above, but don't rely on indirect includes:</a>
<a name="57"><span class="lineNum">      57 </span>            : #include &lt;vector&gt;</a>
<a name="58"><span class="lineNum">      58 </span>            : #include &lt;list&gt;</a>
<a name="59"><span class="lineNum">      59 </span>            : #include &lt;map&gt;</a>
<a name="60"><span class="lineNum">      60 </span>            : #include &lt;utility&gt;</a>
<a name="61"><span class="lineNum">      61 </span>            : </a>
<a name="62"><span class="lineNum">      62 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="63"><span class="lineNum">      63 </span>            : </a>
<a name="64"><span class="lineNum">      64 </span>            : </a>
<a name="65"><span class="lineNum">      65 </span>            : class Q_CORE_EXPORT QDebug</a>
<a name="66"><span class="lineNum">      66 </span>            : {</a>
<a name="67"><span class="lineNum">      67 </span>            :     friend class QMessageLogger;</a>
<a name="68"><span class="lineNum">      68 </span>            :     friend class QDebugStateSaver;</a>
<a name="69"><span class="lineNum">      69 </span>            :     friend class QDebugStateSaverPrivate;</a>
<a name="70"><span class="lineNum">      70 </span>            :     struct Stream {</a>
<a name="71"><span class="lineNum">      71 </span>            :         enum { VerbosityShift = 29, VerbosityMask = 0x7 };</a>
<a name="72"><span class="lineNum">      72 </span>            : </a>
<a name="73"><span class="lineNum">      73 </span>            :         Stream(QIODevice *device) : ts(device), ref(1), type(QtDebugMsg),</a>
<a name="74"><span class="lineNum">      74 </span>            :             space(true), message_output(false), flags(DefaultVerbosity &lt;&lt; VerbosityShift) {}</a>
<a name="75"><span class="lineNum">      75 </span>            :         Stream(QString *string) : ts(string, QIODevice::WriteOnly), ref(1), type(QtDebugMsg),</a>
<a name="76"><span class="lineNum">      76 </span>            :             space(true), message_output(false), flags(DefaultVerbosity &lt;&lt; VerbosityShift) {}</a>
<a name="77"><span class="lineNum">      77 </span>            :         Stream(QtMsgType t) : ts(&amp;buffer, QIODevice::WriteOnly), ref(1), type(t),</a>
<a name="78"><span class="lineNum">      78 </span>            :             space(true), message_output(true), flags(DefaultVerbosity &lt;&lt; VerbosityShift) {}</a>
<a name="79"><span class="lineNum">      79 </span>            :         QTextStream ts;</a>
<a name="80"><span class="lineNum">      80 </span>            :         QString buffer;</a>
<a name="81"><span class="lineNum">      81 </span>            :         int ref;</a>
<a name="82"><span class="lineNum">      82 </span>            :         QtMsgType type;</a>
<a name="83"><span class="lineNum">      83 </span>            :         bool space;</a>
<a name="84"><span class="lineNum">      84 </span>            :         bool message_output;</a>
<a name="85"><span class="lineNum">      85 </span>            :         QMessageLogContext context;</a>
<a name="86"><span class="lineNum">      86 </span>            : </a>
<a name="87"><span class="lineNum">      87 </span>            :         enum FormatFlag { // Note: Bits 29..31 are reserved for the verbose level introduced in 5.6.</a>
<a name="88"><span class="lineNum">      88 </span>            :             NoQuotes = 0x1</a>
<a name="89"><span class="lineNum">      89 </span>            :         };</a>
<a name="90"><span class="lineNum">      90 </span>            : </a>
<a name="91"><span class="lineNum">      91 </span>            :         // ### Qt 6: unify with space, introduce own version member</a>
<a name="92"><span class="lineNum">      92 </span>            :         bool testFlag(FormatFlag flag) const { return (context.version &gt; 1) ? (flags &amp; flag) : false; }</a>
<a name="93"><span class="lineNum">      93 </span>            :         void setFlag(FormatFlag flag) { if (context.version &gt; 1) { flags |= flag; } }</a>
<a name="94"><span class="lineNum">      94 </span>            :         void unsetFlag(FormatFlag flag) { if (context.version &gt; 1) { flags &amp;= ~flag; } }</a>
<a name="95"><span class="lineNum">      95 </span>            :         int verbosity() const</a>
<a name="96"><span class="lineNum">      96 </span>            :         { return context.version &gt; 1 ? (flags &gt;&gt; VerbosityShift) &amp; VerbosityMask : int(DefaultVerbosity); }</a>
<a name="97"><span class="lineNum">      97 </span>            :         void setVerbosity(int v)</a>
<a name="98"><span class="lineNum">      98 </span>            :         {</a>
<a name="99"><span class="lineNum">      99 </span>            :             if (context.version &gt; 1) {</a>
<a name="100"><span class="lineNum">     100 </span>            :                 flags &amp;= ~(uint(VerbosityMask) &lt;&lt; VerbosityShift);</a>
<a name="101"><span class="lineNum">     101 </span>            :                 flags |= (v &amp; VerbosityMask) &lt;&lt; VerbosityShift;</a>
<a name="102"><span class="lineNum">     102 </span>            :             }</a>
<a name="103"><span class="lineNum">     103 </span>            :         }</a>
<a name="104"><span class="lineNum">     104 </span>            :         // added in 5.4</a>
<a name="105"><span class="lineNum">     105 </span>            :         int flags;</a>
<a name="106"><span class="lineNum">     106 </span>            :     } *stream;</a>
<a name="107"><span class="lineNum">     107 </span>            : </a>
<a name="108"><span class="lineNum">     108 </span>            :     enum Latin1Content { ContainsBinary = 0, ContainsLatin1 };</a>
<a name="109"><span class="lineNum">     109 </span>            : </a>
<a name="110"><span class="lineNum">     110 </span>            :     void putUcs4(uint ucs4);</a>
<a name="111"><span class="lineNum">     111 </span>            :     void putString(const QChar *begin, size_t length);</a>
<a name="112"><span class="lineNum">     112 </span>            :     void putByteArray(const char *begin, size_t length, Latin1Content content);</a>
<a name="113"><span class="lineNum">     113 </span>            : public:</a>
<a name="114"><span class="lineNum">     114 </span>            :     inline QDebug(QIODevice *device) : stream(new Stream(device)) {}</a>
<a name="115"><span class="lineNum">     115 </span>            :     inline QDebug(QString *string) : stream(new Stream(string)) {}</a>
<a name="116"><span class="lineNum">     116 </span>            :     inline QDebug(QtMsgType t) : stream(new Stream(t)) {}</a>
<a name="117"><span class="lineNum">     117 </span>            :     inline QDebug(const QDebug &amp;o):stream(o.stream) { ++stream-&gt;ref; }</a>
<a name="118"><span class="lineNum">     118 </span>            :     QDebug(QDebug &amp;&amp;other) noexcept : stream{qExchange(other.stream, nullptr)} {}</a>
<a name="119"><span class="lineNum">     119 </span>            :     inline QDebug &amp;operator=(const QDebug &amp;other);</a>
<a name="120"><span class="lineNum">     120 </span>            :     QDebug &amp;operator=(QDebug &amp;&amp;other) noexcept</a>
<a name="121"><span class="lineNum">     121 </span>            :     { QDebug{std::move(other)}.swap(*this); return *this; }</a>
<a name="122"><span class="lineNum">     122 </span>            :     ~QDebug();</a>
<a name="123"><span class="lineNum">     123 </span>            :     inline void swap(QDebug &amp;other) noexcept { qSwap(stream, other.stream); }</a>
<a name="124"><span class="lineNum">     124 </span>            : </a>
<a name="125"><span class="lineNum">     125 </span>            :     QDebug &amp;resetFormat();</a>
<a name="126"><span class="lineNum">     126 </span>            : </a>
<a name="127"><span class="lineNum">     127 </span>            :     inline QDebug &amp;space() { stream-&gt;space = true; stream-&gt;ts &lt;&lt; ' '; return *this; }</a>
<a name="128"><span class="lineNum">     128 </span>            :     inline QDebug &amp;nospace() { stream-&gt;space = false; return *this; }</a>
<a name="129"><span class="lineNum">     129 </span><span class="lineNoCov">          0 :     inline QDebug &amp;maybeSpace() { if (stream-&gt;space) stream-&gt;ts &lt;&lt; ' '; return *this; }</span></a>
<a name="130"><span class="lineNum">     130 </span>            :     inline QDebug &amp;verbosity(int verbosityLevel) { setVerbosity(verbosityLevel); return *this; }</a>
<a name="131"><span class="lineNum">     131 </span>            :     int verbosity() const { return stream-&gt;verbosity(); }</a>
<a name="132"><span class="lineNum">     132 </span>            :     void setVerbosity(int verbosityLevel) { stream-&gt;setVerbosity(verbosityLevel); }</a>
<a name="133"><span class="lineNum">     133 </span>            :     enum VerbosityLevel { MinimumVerbosity = 0, DefaultVerbosity = 2, MaximumVerbosity = 7 };</a>
<a name="134"><span class="lineNum">     134 </span>            : </a>
<a name="135"><span class="lineNum">     135 </span>            :     bool autoInsertSpaces() const { return stream-&gt;space; }</a>
<a name="136"><span class="lineNum">     136 </span>            :     void setAutoInsertSpaces(bool b) { stream-&gt;space = b; }</a>
<a name="137"><span class="lineNum">     137 </span>            : </a>
<a name="138"><span class="lineNum">     138 </span>            :     inline QDebug &amp;quote() { stream-&gt;unsetFlag(Stream::NoQuotes); return *this; }</a>
<a name="139"><span class="lineNum">     139 </span>            :     inline QDebug &amp;noquote() { stream-&gt;setFlag(Stream::NoQuotes); return *this; }</a>
<a name="140"><span class="lineNum">     140 </span>            :     inline QDebug &amp;maybeQuote(char c = '&quot;') { if (!(stream-&gt;testFlag(Stream::NoQuotes))) stream-&gt;ts &lt;&lt; c; return *this; }</a>
<a name="141"><span class="lineNum">     141 </span>            : </a>
<a name="142"><span class="lineNum">     142 </span>            :     inline QDebug &amp;operator&lt;&lt;(QChar t) { putUcs4(t.unicode()); return maybeSpace(); }</a>
<a name="143"><span class="lineNum">     143 </span>            :     inline QDebug &amp;operator&lt;&lt;(bool t) { stream-&gt;ts &lt;&lt; (t ? &quot;true&quot; : &quot;false&quot;); return maybeSpace(); }</a>
<a name="144"><span class="lineNum">     144 </span>            :     inline QDebug &amp;operator&lt;&lt;(char t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="145"><span class="lineNum">     145 </span>            :     inline QDebug &amp;operator&lt;&lt;(signed short t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="146"><span class="lineNum">     146 </span>            :     inline QDebug &amp;operator&lt;&lt;(unsigned short t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="147"><span class="lineNum">     147 </span>            : #ifdef Q_COMPILER_UNICODE_STRINGS</a>
<a name="148"><span class="lineNum">     148 </span>            :     inline QDebug &amp;operator&lt;&lt;(char16_t t) { return *this &lt;&lt; QChar(ushort(t)); }</a>
<a name="149"><span class="lineNum">     149 </span>            :     inline QDebug &amp;operator&lt;&lt;(char32_t t) { putUcs4(t); return maybeSpace(); }</a>
<a name="150"><span class="lineNum">     150 </span>            : #endif</a>
<a name="151"><span class="lineNum">     151 </span>            :     inline QDebug &amp;operator&lt;&lt;(signed int t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="152"><span class="lineNum">     152 </span>            :     inline QDebug &amp;operator&lt;&lt;(unsigned int t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="153"><span class="lineNum">     153 </span>            :     inline QDebug &amp;operator&lt;&lt;(signed long t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="154"><span class="lineNum">     154 </span>            :     inline QDebug &amp;operator&lt;&lt;(unsigned long t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="155"><span class="lineNum">     155 </span>            :     inline QDebug &amp;operator&lt;&lt;(qint64 t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="156"><span class="lineNum">     156 </span>            :     inline QDebug &amp;operator&lt;&lt;(quint64 t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="157"><span class="lineNum">     157 </span>            :     inline QDebug &amp;operator&lt;&lt;(float t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="158"><span class="lineNum">     158 </span>            :     inline QDebug &amp;operator&lt;&lt;(double t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="159"><span class="lineNum">     159 </span><span class="lineNoCov">          0 :     inline QDebug &amp;operator&lt;&lt;(const char* t) { stream-&gt;ts &lt;&lt; QString::fromUtf8(t); return maybeSpace(); }</span></a>
<a name="160"><span class="lineNum">     160 </span>            : #if QT_STRINGVIEW_LEVEL &lt; 2</a>
<a name="161"><span class="lineNum">     161 </span><span class="lineNoCov">          0 :     inline QDebug &amp;operator&lt;&lt;(const QString &amp; t) { putString(t.constData(), uint(t.length())); return maybeSpace(); }</span></a>
<a name="162"><span class="lineNum">     162 </span>            :     inline QDebug &amp;operator&lt;&lt;(const QStringRef &amp; t) { putString(t.constData(), uint(t.length())); return maybeSpace(); }</a>
<a name="163"><span class="lineNum">     163 </span>            : #endif</a>
<a name="164"><span class="lineNum">     164 </span>            :     inline QDebug &amp;operator&lt;&lt;(QStringView s) { putString(s.data(), size_t(s.size())); return maybeSpace(); }</a>
<a name="165"><span class="lineNum">     165 </span>            :     inline QDebug &amp;operator&lt;&lt;(QLatin1String t) { putByteArray(t.latin1(), t.size(), ContainsLatin1); return maybeSpace(); }</a>
<a name="166"><span class="lineNum">     166 </span>            :     inline QDebug &amp;operator&lt;&lt;(const QByteArray &amp; t) { putByteArray(t.constData(), t.size(), ContainsBinary); return maybeSpace(); }</a>
<a name="167"><span class="lineNum">     167 </span>            :     inline QDebug &amp;operator&lt;&lt;(const void * t) { stream-&gt;ts &lt;&lt; t; return maybeSpace(); }</a>
<a name="168"><span class="lineNum">     168 </span>            :     inline QDebug &amp;operator&lt;&lt;(std::nullptr_t) { stream-&gt;ts &lt;&lt; &quot;(nullptr)&quot;; return maybeSpace(); }</a>
<a name="169"><span class="lineNum">     169 </span>            :     inline QDebug &amp;operator&lt;&lt;(QTextStreamFunction f) {</a>
<a name="170"><span class="lineNum">     170 </span>            :         stream-&gt;ts &lt;&lt; f;</a>
<a name="171"><span class="lineNum">     171 </span>            :         return *this;</a>
<a name="172"><span class="lineNum">     172 </span>            :     }</a>
<a name="173"><span class="lineNum">     173 </span>            : </a>
<a name="174"><span class="lineNum">     174 </span>            :     inline QDebug &amp;operator&lt;&lt;(QTextStreamManipulator m)</a>
<a name="175"><span class="lineNum">     175 </span>            :     { stream-&gt;ts &lt;&lt; m; return *this; }</a>
<a name="176"><span class="lineNum">     176 </span>            : };</a>
<a name="177"><span class="lineNum">     177 </span>            : </a>
<a name="178"><span class="lineNum">     178 </span>            : Q_DECLARE_SHARED(QDebug)</a>
<a name="179"><span class="lineNum">     179 </span>            : </a>
<a name="180"><span class="lineNum">     180 </span>            : class QDebugStateSaverPrivate;</a>
<a name="181"><span class="lineNum">     181 </span>            : class Q_CORE_EXPORT QDebugStateSaver</a>
<a name="182"><span class="lineNum">     182 </span>            : {</a>
<a name="183"><span class="lineNum">     183 </span>            : public:</a>
<a name="184"><span class="lineNum">     184 </span>            :     QDebugStateSaver(QDebug &amp;dbg);</a>
<a name="185"><span class="lineNum">     185 </span>            :     ~QDebugStateSaver();</a>
<a name="186"><span class="lineNum">     186 </span>            : private:</a>
<a name="187"><span class="lineNum">     187 </span>            :     Q_DISABLE_COPY(QDebugStateSaver)</a>
<a name="188"><span class="lineNum">     188 </span>            :     QScopedPointer&lt;QDebugStateSaverPrivate&gt; d;</a>
<a name="189"><span class="lineNum">     189 </span>            : };</a>
<a name="190"><span class="lineNum">     190 </span>            : </a>
<a name="191"><span class="lineNum">     191 </span>            : class QNoDebug</a>
<a name="192"><span class="lineNum">     192 </span>            : {</a>
<a name="193"><span class="lineNum">     193 </span>            : public:</a>
<a name="194"><span class="lineNum">     194 </span>            :     inline QNoDebug &amp;operator&lt;&lt;(QTextStreamFunction) { return *this; }</a>
<a name="195"><span class="lineNum">     195 </span>            :     inline QNoDebug &amp;operator&lt;&lt;(QTextStreamManipulator) { return *this; }</a>
<a name="196"><span class="lineNum">     196 </span>            :     inline QNoDebug &amp;space() { return *this; }</a>
<a name="197"><span class="lineNum">     197 </span>            :     inline QNoDebug &amp;nospace() { return *this; }</a>
<a name="198"><span class="lineNum">     198 </span>            :     inline QNoDebug &amp;maybeSpace() { return *this; }</a>
<a name="199"><span class="lineNum">     199 </span>            :     inline QNoDebug &amp;quote() { return *this; }</a>
<a name="200"><span class="lineNum">     200 </span>            :     inline QNoDebug &amp;noquote() { return *this; }</a>
<a name="201"><span class="lineNum">     201 </span>            :     inline QNoDebug &amp;maybeQuote(const char = '&quot;') { return *this; }</a>
<a name="202"><span class="lineNum">     202 </span>            :     inline QNoDebug &amp;verbosity(int) { return *this; }</a>
<a name="203"><span class="lineNum">     203 </span>            : </a>
<a name="204"><span class="lineNum">     204 </span>            :     template&lt;typename T&gt;</a>
<a name="205"><span class="lineNum">     205 </span>            :     inline QNoDebug &amp;operator&lt;&lt;(const T &amp;) { return *this; }</a>
<a name="206"><span class="lineNum">     206 </span>            : };</a>
<a name="207"><span class="lineNum">     207 </span>            : </a>
<a name="208"><span class="lineNum">     208 </span>            : inline QDebug &amp;QDebug::operator=(const QDebug &amp;other)</a>
<a name="209"><span class="lineNum">     209 </span>            : {</a>
<a name="210"><span class="lineNum">     210 </span>            :     QDebug{other}.swap(*this);</a>
<a name="211"><span class="lineNum">     211 </span>            :     return *this;</a>
<a name="212"><span class="lineNum">     212 </span>            : }</a>
<a name="213"><span class="lineNum">     213 </span>            : </a>
<a name="214"><span class="lineNum">     214 </span>            : namespace QtPrivate {</a>
<a name="215"><span class="lineNum">     215 </span>            : </a>
<a name="216"><span class="lineNum">     216 </span>            : template &lt;typename SequentialContainer&gt;</a>
<a name="217"><span class="lineNum">     217 </span>            : inline QDebug printSequentialContainer(QDebug debug, const char *which, const SequentialContainer &amp;c)</a>
<a name="218"><span class="lineNum">     218 </span>            : {</a>
<a name="219"><span class="lineNum">     219 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="220"><span class="lineNum">     220 </span>            :     debug.nospace() &lt;&lt; which &lt;&lt; '(';</a>
<a name="221"><span class="lineNum">     221 </span>            :     typename SequentialContainer::const_iterator it = c.begin(), end = c.end();</a>
<a name="222"><span class="lineNum">     222 </span>            :     if (it != end) {</a>
<a name="223"><span class="lineNum">     223 </span>            :         debug &lt;&lt; *it;</a>
<a name="224"><span class="lineNum">     224 </span>            :         ++it;</a>
<a name="225"><span class="lineNum">     225 </span>            :     }</a>
<a name="226"><span class="lineNum">     226 </span>            :     while (it != end) {</a>
<a name="227"><span class="lineNum">     227 </span>            :         debug &lt;&lt; &quot;, &quot; &lt;&lt; *it;</a>
<a name="228"><span class="lineNum">     228 </span>            :         ++it;</a>
<a name="229"><span class="lineNum">     229 </span>            :     }</a>
<a name="230"><span class="lineNum">     230 </span>            :     debug &lt;&lt; ')';</a>
<a name="231"><span class="lineNum">     231 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="232"><span class="lineNum">     232 </span>            :     return debug.maybeSpace();</a>
<a name="233"><span class="lineNum">     233 </span>            : }</a>
<a name="234"><span class="lineNum">     234 </span>            : </a>
<a name="235"><span class="lineNum">     235 </span>            : } // namespace QtPrivate</a>
<a name="236"><span class="lineNum">     236 </span>            : </a>
<a name="237"><span class="lineNum">     237 </span>            : template &lt;class T&gt;</a>
<a name="238"><span class="lineNum">     238 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QList&lt;T&gt; &amp;list)</a>
<a name="239"><span class="lineNum">     239 </span>            : {</a>
<a name="240"><span class="lineNum">     240 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;&quot; /*for historical reasons*/, list);</a>
<a name="241"><span class="lineNum">     241 </span>            : }</a>
<a name="242"><span class="lineNum">     242 </span>            : </a>
<a name="243"><span class="lineNum">     243 </span>            : template &lt;typename T&gt;</a>
<a name="244"><span class="lineNum">     244 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QVector&lt;T&gt; &amp;vec)</a>
<a name="245"><span class="lineNum">     245 </span>            : {</a>
<a name="246"><span class="lineNum">     246 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;QVector&quot;, vec);</a>
<a name="247"><span class="lineNum">     247 </span>            : }</a>
<a name="248"><span class="lineNum">     248 </span>            : </a>
<a name="249"><span class="lineNum">     249 </span>            : template &lt;typename T, typename Alloc&gt;</a>
<a name="250"><span class="lineNum">     250 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const std::vector&lt;T, Alloc&gt; &amp;vec)</a>
<a name="251"><span class="lineNum">     251 </span>            : {</a>
<a name="252"><span class="lineNum">     252 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;std::vector&quot;, vec);</a>
<a name="253"><span class="lineNum">     253 </span>            : }</a>
<a name="254"><span class="lineNum">     254 </span>            : </a>
<a name="255"><span class="lineNum">     255 </span>            : template &lt;typename T, typename Alloc&gt;</a>
<a name="256"><span class="lineNum">     256 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const std::list&lt;T, Alloc&gt; &amp;vec)</a>
<a name="257"><span class="lineNum">     257 </span>            : {</a>
<a name="258"><span class="lineNum">     258 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;std::list&quot;, vec);</a>
<a name="259"><span class="lineNum">     259 </span>            : }</a>
<a name="260"><span class="lineNum">     260 </span>            : </a>
<a name="261"><span class="lineNum">     261 </span>            : template &lt;typename Key, typename T, typename Compare, typename Alloc&gt;</a>
<a name="262"><span class="lineNum">     262 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const std::map&lt;Key, T, Compare, Alloc&gt; &amp;map)</a>
<a name="263"><span class="lineNum">     263 </span>            : {</a>
<a name="264"><span class="lineNum">     264 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;std::map&quot;, map); // yes, sequential: *it is std::pair</a>
<a name="265"><span class="lineNum">     265 </span>            : }</a>
<a name="266"><span class="lineNum">     266 </span>            : </a>
<a name="267"><span class="lineNum">     267 </span>            : template &lt;typename Key, typename T, typename Compare, typename Alloc&gt;</a>
<a name="268"><span class="lineNum">     268 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const std::multimap&lt;Key, T, Compare, Alloc&gt; &amp;map)</a>
<a name="269"><span class="lineNum">     269 </span>            : {</a>
<a name="270"><span class="lineNum">     270 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;std::multimap&quot;, map); // yes, sequential: *it is std::pair</a>
<a name="271"><span class="lineNum">     271 </span>            : }</a>
<a name="272"><span class="lineNum">     272 </span>            : </a>
<a name="273"><span class="lineNum">     273 </span>            : template &lt;class Key, class T&gt;</a>
<a name="274"><span class="lineNum">     274 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QMap&lt;Key, T&gt; &amp;map)</a>
<a name="275"><span class="lineNum">     275 </span>            : {</a>
<a name="276"><span class="lineNum">     276 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="277"><span class="lineNum">     277 </span>            :     debug.nospace() &lt;&lt; &quot;QMap(&quot;;</a>
<a name="278"><span class="lineNum">     278 </span>            :     for (typename QMap&lt;Key, T&gt;::const_iterator it = map.constBegin();</a>
<a name="279"><span class="lineNum">     279 </span>            :          it != map.constEnd(); ++it) {</a>
<a name="280"><span class="lineNum">     280 </span>            :         debug &lt;&lt; '(' &lt;&lt; it.key() &lt;&lt; &quot;, &quot; &lt;&lt; it.value() &lt;&lt; ')';</a>
<a name="281"><span class="lineNum">     281 </span>            :     }</a>
<a name="282"><span class="lineNum">     282 </span>            :     debug &lt;&lt; ')';</a>
<a name="283"><span class="lineNum">     283 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="284"><span class="lineNum">     284 </span>            :     return debug.maybeSpace();</a>
<a name="285"><span class="lineNum">     285 </span>            : }</a>
<a name="286"><span class="lineNum">     286 </span>            : </a>
<a name="287"><span class="lineNum">     287 </span>            : template &lt;class Key, class T&gt;</a>
<a name="288"><span class="lineNum">     288 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QHash&lt;Key, T&gt; &amp;hash)</a>
<a name="289"><span class="lineNum">     289 </span>            : {</a>
<a name="290"><span class="lineNum">     290 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="291"><span class="lineNum">     291 </span>            :     debug.nospace() &lt;&lt; &quot;QHash(&quot;;</a>
<a name="292"><span class="lineNum">     292 </span>            :     for (typename QHash&lt;Key, T&gt;::const_iterator it = hash.constBegin();</a>
<a name="293"><span class="lineNum">     293 </span>            :             it != hash.constEnd(); ++it)</a>
<a name="294"><span class="lineNum">     294 </span>            :         debug &lt;&lt; '(' &lt;&lt; it.key() &lt;&lt; &quot;, &quot; &lt;&lt; it.value() &lt;&lt; ')';</a>
<a name="295"><span class="lineNum">     295 </span>            :     debug &lt;&lt; ')';</a>
<a name="296"><span class="lineNum">     296 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="297"><span class="lineNum">     297 </span>            :     return debug.maybeSpace();</a>
<a name="298"><span class="lineNum">     298 </span>            : }</a>
<a name="299"><span class="lineNum">     299 </span>            : </a>
<a name="300"><span class="lineNum">     300 </span>            : template &lt;class T1, class T2&gt;</a>
<a name="301"><span class="lineNum">     301 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QPair&lt;T1, T2&gt; &amp;pair)</a>
<a name="302"><span class="lineNum">     302 </span>            : {</a>
<a name="303"><span class="lineNum">     303 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="304"><span class="lineNum">     304 </span>            :     debug.nospace() &lt;&lt; &quot;QPair(&quot; &lt;&lt; pair.first &lt;&lt; ',' &lt;&lt; pair.second &lt;&lt; ')';</a>
<a name="305"><span class="lineNum">     305 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="306"><span class="lineNum">     306 </span>            :     return debug.maybeSpace();</a>
<a name="307"><span class="lineNum">     307 </span>            : }</a>
<a name="308"><span class="lineNum">     308 </span>            : </a>
<a name="309"><span class="lineNum">     309 </span>            : template &lt;class T1, class T2&gt;</a>
<a name="310"><span class="lineNum">     310 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const std::pair&lt;T1, T2&gt; &amp;pair)</a>
<a name="311"><span class="lineNum">     311 </span>            : {</a>
<a name="312"><span class="lineNum">     312 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="313"><span class="lineNum">     313 </span>            :     debug.nospace() &lt;&lt; &quot;std::pair(&quot; &lt;&lt; pair.first &lt;&lt; ',' &lt;&lt; pair.second &lt;&lt; ')';</a>
<a name="314"><span class="lineNum">     314 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="315"><span class="lineNum">     315 </span>            :     return debug.maybeSpace();</a>
<a name="316"><span class="lineNum">     316 </span>            : }</a>
<a name="317"><span class="lineNum">     317 </span>            : </a>
<a name="318"><span class="lineNum">     318 </span>            : template &lt;typename T&gt;</a>
<a name="319"><span class="lineNum">     319 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QSet&lt;T&gt; &amp;set)</a>
<a name="320"><span class="lineNum">     320 </span>            : {</a>
<a name="321"><span class="lineNum">     321 </span>            :     return QtPrivate::printSequentialContainer(debug, &quot;QSet&quot;, set);</a>
<a name="322"><span class="lineNum">     322 </span>            : }</a>
<a name="323"><span class="lineNum">     323 </span>            : </a>
<a name="324"><span class="lineNum">     324 </span>            : template &lt;class T&gt;</a>
<a name="325"><span class="lineNum">     325 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QContiguousCache&lt;T&gt; &amp;cache)</a>
<a name="326"><span class="lineNum">     326 </span>            : {</a>
<a name="327"><span class="lineNum">     327 </span>            :     const bool oldSetting = debug.autoInsertSpaces();</a>
<a name="328"><span class="lineNum">     328 </span>            :     debug.nospace() &lt;&lt; &quot;QContiguousCache(&quot;;</a>
<a name="329"><span class="lineNum">     329 </span>            :     for (int i = cache.firstIndex(); i &lt;= cache.lastIndex(); ++i) {</a>
<a name="330"><span class="lineNum">     330 </span>            :         debug &lt;&lt; cache[i];</a>
<a name="331"><span class="lineNum">     331 </span>            :         if (i != cache.lastIndex())</a>
<a name="332"><span class="lineNum">     332 </span>            :             debug &lt;&lt; &quot;, &quot;;</a>
<a name="333"><span class="lineNum">     333 </span>            :     }</a>
<a name="334"><span class="lineNum">     334 </span>            :     debug &lt;&lt; ')';</a>
<a name="335"><span class="lineNum">     335 </span>            :     debug.setAutoInsertSpaces(oldSetting);</a>
<a name="336"><span class="lineNum">     336 </span>            :     return debug.maybeSpace();</a>
<a name="337"><span class="lineNum">     337 </span>            : }</a>
<a name="338"><span class="lineNum">     338 </span>            : </a>
<a name="339"><span class="lineNum">     339 </span>            : template &lt;class T&gt;</a>
<a name="340"><span class="lineNum">     340 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QSharedPointer&lt;T&gt; &amp;ptr)</a>
<a name="341"><span class="lineNum">     341 </span>            : {</a>
<a name="342"><span class="lineNum">     342 </span>            :     QDebugStateSaver saver(debug);</a>
<a name="343"><span class="lineNum">     343 </span>            :     debug.nospace() &lt;&lt; &quot;QSharedPointer(&quot; &lt;&lt; ptr.data() &lt;&lt; &quot;)&quot;;</a>
<a name="344"><span class="lineNum">     344 </span>            :     return debug;</a>
<a name="345"><span class="lineNum">     345 </span>            : }</a>
<a name="346"><span class="lineNum">     346 </span>            : </a>
<a name="347"><span class="lineNum">     347 </span>            : Q_CORE_EXPORT void qt_QMetaEnum_flagDebugOperator(QDebug &amp;debug, size_t sizeofT, int value);</a>
<a name="348"><span class="lineNum">     348 </span>            : </a>
<a name="349"><span class="lineNum">     349 </span>            : template &lt;typename Int&gt;</a>
<a name="350"><span class="lineNum">     350 </span>            : void qt_QMetaEnum_flagDebugOperator(QDebug &amp;debug, size_t sizeofT, Int value)</a>
<a name="351"><span class="lineNum">     351 </span>            : {</a>
<a name="352"><span class="lineNum">     352 </span>            :     const QDebugStateSaver saver(debug);</a>
<a name="353"><span class="lineNum">     353 </span>            :     debug.resetFormat();</a>
<a name="354"><span class="lineNum">     354 </span>            :     debug.nospace() &lt;&lt; &quot;QFlags(&quot; &lt;&lt; Qt::hex &lt;&lt; Qt::showbase;</a>
<a name="355"><span class="lineNum">     355 </span>            :     bool needSeparator = false;</a>
<a name="356"><span class="lineNum">     356 </span>            :     for (uint i = 0; i &lt; sizeofT * 8; ++i) {</a>
<a name="357"><span class="lineNum">     357 </span>            :         if (value &amp; (Int(1) &lt;&lt; i)) {</a>
<a name="358"><span class="lineNum">     358 </span>            :             if (needSeparator)</a>
<a name="359"><span class="lineNum">     359 </span>            :                 debug &lt;&lt; '|';</a>
<a name="360"><span class="lineNum">     360 </span>            :             else</a>
<a name="361"><span class="lineNum">     361 </span>            :                 needSeparator = true;</a>
<a name="362"><span class="lineNum">     362 </span>            :             debug &lt;&lt; (Int(1) &lt;&lt; i);</a>
<a name="363"><span class="lineNum">     363 </span>            :         }</a>
<a name="364"><span class="lineNum">     364 </span>            :     }</a>
<a name="365"><span class="lineNum">     365 </span>            :     debug &lt;&lt; ')';</a>
<a name="366"><span class="lineNum">     366 </span>            : }</a>
<a name="367"><span class="lineNum">     367 </span>            : </a>
<a name="368"><span class="lineNum">     368 </span>            : #if !defined(QT_NO_QOBJECT) &amp;&amp; !defined(Q_QDOC)</a>
<a name="369"><span class="lineNum">     369 </span>            : Q_CORE_EXPORT QDebug qt_QMetaEnum_debugOperator(QDebug&amp;, int value, const QMetaObject *meta, const char *name);</a>
<a name="370"><span class="lineNum">     370 </span>            : Q_CORE_EXPORT QDebug qt_QMetaEnum_flagDebugOperator(QDebug &amp;dbg, quint64 value, const QMetaObject *meta, const char *name);</a>
<a name="371"><span class="lineNum">     371 </span>            : </a>
<a name="372"><span class="lineNum">     372 </span>            : template&lt;typename T&gt;</a>
<a name="373"><span class="lineNum">     373 </span>            : typename std::enable_if&lt;QtPrivate::IsQEnumHelper&lt;T&gt;::Value, QDebug&gt;::type</a>
<a name="374"><span class="lineNum">     374 </span>            : operator&lt;&lt;(QDebug dbg, T value)</a>
<a name="375"><span class="lineNum">     375 </span>            : {</a>
<a name="376"><span class="lineNum">     376 </span>            :     const QMetaObject *obj = qt_getEnumMetaObject(value);</a>
<a name="377"><span class="lineNum">     377 </span>            :     const char *name = qt_getEnumName(value);</a>
<a name="378"><span class="lineNum">     378 </span>            :     return qt_QMetaEnum_debugOperator(dbg, typename QFlags&lt;T&gt;::Int(value), obj, name);</a>
<a name="379"><span class="lineNum">     379 </span>            : }</a>
<a name="380"><span class="lineNum">     380 </span>            : </a>
<a name="381"><span class="lineNum">     381 </span>            : template&lt;typename T,</a>
<a name="382"><span class="lineNum">     382 </span>            :          typename A = typename std::enable_if&lt;std::is_enum&lt;T&gt;::value, void&gt;::type,</a>
<a name="383"><span class="lineNum">     383 </span>            :          typename B = typename std::enable_if&lt;sizeof(T) &lt;= sizeof(int), void&gt;::type,</a>
<a name="384"><span class="lineNum">     384 </span>            :          typename C = typename std::enable_if&lt;!QtPrivate::IsQEnumHelper&lt;T&gt;::Value, void&gt;::type,</a>
<a name="385"><span class="lineNum">     385 </span>            :          typename D = typename std::enable_if&lt;QtPrivate::IsQEnumHelper&lt;QFlags&lt;T&gt;&gt;::Value, void&gt;::type&gt;</a>
<a name="386"><span class="lineNum">     386 </span>            : inline QDebug operator&lt;&lt;(QDebug dbg, T value)</a>
<a name="387"><span class="lineNum">     387 </span>            : {</a>
<a name="388"><span class="lineNum">     388 </span>            :     typedef QFlags&lt;T&gt; FlagsT;</a>
<a name="389"><span class="lineNum">     389 </span>            :     const QMetaObject *obj = qt_getEnumMetaObject(FlagsT());</a>
<a name="390"><span class="lineNum">     390 </span>            :     const char *name = qt_getEnumName(FlagsT());</a>
<a name="391"><span class="lineNum">     391 </span>            :     return qt_QMetaEnum_debugOperator(dbg, typename FlagsT::Int(value), obj, name);</a>
<a name="392"><span class="lineNum">     392 </span>            : }</a>
<a name="393"><span class="lineNum">     393 </span>            : </a>
<a name="394"><span class="lineNum">     394 </span>            : template &lt;class T&gt;</a>
<a name="395"><span class="lineNum">     395 </span>            : inline typename std::enable_if&lt;</a>
<a name="396"><span class="lineNum">     396 </span>            :     QtPrivate::IsQEnumHelper&lt;T&gt;::Value || QtPrivate::IsQEnumHelper&lt;QFlags&lt;T&gt; &gt;::Value,</a>
<a name="397"><span class="lineNum">     397 </span>            :     QDebug&gt;::type</a>
<a name="398"><span class="lineNum">     398 </span>            : qt_QMetaEnum_flagDebugOperator_helper(QDebug debug, const QFlags&lt;T&gt; &amp;flags)</a>
<a name="399"><span class="lineNum">     399 </span>            : {</a>
<a name="400"><span class="lineNum">     400 </span>            :     const QMetaObject *obj = qt_getEnumMetaObject(T());</a>
<a name="401"><span class="lineNum">     401 </span>            :     const char *name = qt_getEnumName(T());</a>
<a name="402"><span class="lineNum">     402 </span>            :     return qt_QMetaEnum_flagDebugOperator(debug, quint64(flags), obj, name);</a>
<a name="403"><span class="lineNum">     403 </span>            : }</a>
<a name="404"><span class="lineNum">     404 </span>            : </a>
<a name="405"><span class="lineNum">     405 </span>            : template &lt;class T&gt;</a>
<a name="406"><span class="lineNum">     406 </span>            : inline typename std::enable_if&lt;</a>
<a name="407"><span class="lineNum">     407 </span>            :     !QtPrivate::IsQEnumHelper&lt;T&gt;::Value &amp;&amp; !QtPrivate::IsQEnumHelper&lt;QFlags&lt;T&gt; &gt;::Value,</a>
<a name="408"><span class="lineNum">     408 </span>            :     QDebug&gt;::type</a>
<a name="409"><span class="lineNum">     409 </span>            : qt_QMetaEnum_flagDebugOperator_helper(QDebug debug, const QFlags&lt;T&gt; &amp;flags)</a>
<a name="410"><span class="lineNum">     410 </span>            : #else // !QT_NO_QOBJECT &amp;&amp; !Q_QDOC</a>
<a name="411"><span class="lineNum">     411 </span>            : template &lt;class T&gt;</a>
<a name="412"><span class="lineNum">     412 </span>            : inline QDebug qt_QMetaEnum_flagDebugOperator_helper(QDebug debug, const QFlags&lt;T&gt; &amp;flags)</a>
<a name="413"><span class="lineNum">     413 </span>            : #endif</a>
<a name="414"><span class="lineNum">     414 </span>            : {</a>
<a name="415"><span class="lineNum">     415 </span>            :     qt_QMetaEnum_flagDebugOperator(debug, sizeof(T), typename QFlags&lt;T&gt;::Int(flags));</a>
<a name="416"><span class="lineNum">     416 </span>            :     return debug;</a>
<a name="417"><span class="lineNum">     417 </span>            : }</a>
<a name="418"><span class="lineNum">     418 </span>            : </a>
<a name="419"><span class="lineNum">     419 </span>            : template&lt;typename T&gt;</a>
<a name="420"><span class="lineNum">     420 </span>            : inline QDebug operator&lt;&lt;(QDebug debug, const QFlags&lt;T&gt; &amp;flags)</a>
<a name="421"><span class="lineNum">     421 </span>            : {</a>
<a name="422"><span class="lineNum">     422 </span>            :     // We have to use an indirection otherwise specialisation of some other overload of the</a>
<a name="423"><span class="lineNum">     423 </span>            :     // operator&lt;&lt; the compiler would try to instantiate QFlags&lt;T&gt; for the std::enable_if</a>
<a name="424"><span class="lineNum">     424 </span>            :     return qt_QMetaEnum_flagDebugOperator_helper(debug, flags);</a>
<a name="425"><span class="lineNum">     425 </span>            : }</a>
<a name="426"><span class="lineNum">     426 </span>            : </a>
<a name="427"><span class="lineNum">     427 </span>            : #ifdef Q_OS_MAC</a>
<a name="428"><span class="lineNum">     428 </span>            : </a>
<a name="429"><span class="lineNum">     429 </span>            : // We provide QDebug stream operators for commonly used Core Foundation</a>
<a name="430"><span class="lineNum">     430 </span>            : // and Core Graphics types, as well as NSObject. Additional CF/CG types</a>
<a name="431"><span class="lineNum">     431 </span>            : // may be added by the user, using Q_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE.</a>
<a name="432"><span class="lineNum">     432 </span>            : </a>
<a name="433"><span class="lineNum">     433 </span>            : #define QT_FOR_EACH_CORE_FOUNDATION_TYPE(F) \</a>
<a name="434"><span class="lineNum">     434 </span>            :     F(CFArray) \</a>
<a name="435"><span class="lineNum">     435 </span>            :     F(CFURL) \</a>
<a name="436"><span class="lineNum">     436 </span>            :     F(CFData) \</a>
<a name="437"><span class="lineNum">     437 </span>            :     F(CFNumber) \</a>
<a name="438"><span class="lineNum">     438 </span>            :     F(CFDictionary) \</a>
<a name="439"><span class="lineNum">     439 </span>            :     F(CFLocale) \</a>
<a name="440"><span class="lineNum">     440 </span>            :     F(CFDate) \</a>
<a name="441"><span class="lineNum">     441 </span>            :     F(CFBoolean) \</a>
<a name="442"><span class="lineNum">     442 </span>            :     F(CFTimeZone) \</a>
<a name="443"><span class="lineNum">     443 </span>            : </a>
<a name="444"><span class="lineNum">     444 </span>            : #define QT_FOR_EACH_MUTABLE_CORE_FOUNDATION_TYPE(F) \</a>
<a name="445"><span class="lineNum">     445 </span>            :     F(CFError) \</a>
<a name="446"><span class="lineNum">     446 </span>            :     F(CFBundle) \</a>
<a name="447"><span class="lineNum">     447 </span>            : </a>
<a name="448"><span class="lineNum">     448 </span>            : #define QT_FOR_EACH_CORE_GRAPHICS_TYPE(F) \</a>
<a name="449"><span class="lineNum">     449 </span>            :     F(CGPath) \</a>
<a name="450"><span class="lineNum">     450 </span>            : </a>
<a name="451"><span class="lineNum">     451 </span>            : #define QT_FOR_EACH_MUTABLE_CORE_GRAPHICS_TYPE(F) \</a>
<a name="452"><span class="lineNum">     452 </span>            :     F(CGColorSpace) \</a>
<a name="453"><span class="lineNum">     453 </span>            :     F(CGImage) \</a>
<a name="454"><span class="lineNum">     454 </span>            :     F(CGFont) \</a>
<a name="455"><span class="lineNum">     455 </span>            :     F(CGColor) \</a>
<a name="456"><span class="lineNum">     456 </span>            : </a>
<a name="457"><span class="lineNum">     457 </span>            : #define QT_FORWARD_DECLARE_CF_TYPE(type) Q_FORWARD_DECLARE_CF_TYPE(type);</a>
<a name="458"><span class="lineNum">     458 </span>            : #define QT_FORWARD_DECLARE_MUTABLE_CF_TYPE(type) Q_FORWARD_DECLARE_MUTABLE_CF_TYPE(type);</a>
<a name="459"><span class="lineNum">     459 </span>            : #define QT_FORWARD_DECLARE_CG_TYPE(type) Q_FORWARD_DECLARE_CG_TYPE(type);</a>
<a name="460"><span class="lineNum">     460 </span>            : #define QT_FORWARD_DECLARE_MUTABLE_CG_TYPE(type) Q_FORWARD_DECLARE_MUTABLE_CG_TYPE(type);</a>
<a name="461"><span class="lineNum">     461 </span>            : </a>
<a name="462"><span class="lineNum">     462 </span>            : QT_END_NAMESPACE</a>
<a name="463"><span class="lineNum">     463 </span>            : Q_FORWARD_DECLARE_CF_TYPE(CFString);</a>
<a name="464"><span class="lineNum">     464 </span>            : Q_FORWARD_DECLARE_OBJC_CLASS(NSObject);</a>
<a name="465"><span class="lineNum">     465 </span>            : QT_FOR_EACH_CORE_FOUNDATION_TYPE(QT_FORWARD_DECLARE_CF_TYPE)</a>
<a name="466"><span class="lineNum">     466 </span>            : QT_FOR_EACH_MUTABLE_CORE_FOUNDATION_TYPE(QT_FORWARD_DECLARE_MUTABLE_CF_TYPE)</a>
<a name="467"><span class="lineNum">     467 </span>            : QT_FOR_EACH_CORE_GRAPHICS_TYPE(QT_FORWARD_DECLARE_CG_TYPE)</a>
<a name="468"><span class="lineNum">     468 </span>            : QT_FOR_EACH_MUTABLE_CORE_GRAPHICS_TYPE(QT_FORWARD_DECLARE_MUTABLE_CG_TYPE)</a>
<a name="469"><span class="lineNum">     469 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="470"><span class="lineNum">     470 </span>            : </a>
<a name="471"><span class="lineNum">     471 </span>            : #define QT_FORWARD_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE(CFType) \</a>
<a name="472"><span class="lineNum">     472 </span>            :     Q_CORE_EXPORT QDebug operator&lt;&lt;(QDebug, CFType##Ref);</a>
<a name="473"><span class="lineNum">     473 </span>            : </a>
<a name="474"><span class="lineNum">     474 </span>            : #define Q_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE(CFType) \</a>
<a name="475"><span class="lineNum">     475 </span>            :     QDebug operator&lt;&lt;(QDebug debug, CFType##Ref ref) \</a>
<a name="476"><span class="lineNum">     476 </span>            :     { \</a>
<a name="477"><span class="lineNum">     477 </span>            :         if (!ref) \</a>
<a name="478"><span class="lineNum">     478 </span>            :             return debug &lt;&lt; QT_STRINGIFY(CFType) &quot;Ref(0x0)&quot;; \</a>
<a name="479"><span class="lineNum">     479 </span>            :         if (CFStringRef description = CFCopyDescription(ref)) { \</a>
<a name="480"><span class="lineNum">     480 </span>            :             QDebugStateSaver saver(debug); \</a>
<a name="481"><span class="lineNum">     481 </span>            :             debug.noquote() &lt;&lt; description; \</a>
<a name="482"><span class="lineNum">     482 </span>            :             CFRelease(description); \</a>
<a name="483"><span class="lineNum">     483 </span>            :         } \</a>
<a name="484"><span class="lineNum">     484 </span>            :         return debug; \</a>
<a name="485"><span class="lineNum">     485 </span>            :     }</a>
<a name="486"><span class="lineNum">     486 </span>            : </a>
<a name="487"><span class="lineNum">     487 </span>            : // Defined in qcore_mac_objc.mm</a>
<a name="488"><span class="lineNum">     488 </span>            : Q_CORE_EXPORT QDebug operator&lt;&lt;(QDebug, const NSObject *);</a>
<a name="489"><span class="lineNum">     489 </span>            : Q_CORE_EXPORT QDebug operator&lt;&lt;(QDebug, CFStringRef);</a>
<a name="490"><span class="lineNum">     490 </span>            : </a>
<a name="491"><span class="lineNum">     491 </span>            : QT_FOR_EACH_CORE_FOUNDATION_TYPE(QT_FORWARD_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE)</a>
<a name="492"><span class="lineNum">     492 </span>            : QT_FOR_EACH_MUTABLE_CORE_FOUNDATION_TYPE(QT_FORWARD_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE)</a>
<a name="493"><span class="lineNum">     493 </span>            : QT_FOR_EACH_CORE_GRAPHICS_TYPE(QT_FORWARD_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE)</a>
<a name="494"><span class="lineNum">     494 </span>            : QT_FOR_EACH_MUTABLE_CORE_GRAPHICS_TYPE(QT_FORWARD_DECLARE_QDEBUG_OPERATOR_FOR_CF_TYPE)</a>
<a name="495"><span class="lineNum">     495 </span>            : </a>
<a name="496"><span class="lineNum">     496 </span>            : #undef QT_FORWARD_DECLARE_CF_TYPE</a>
<a name="497"><span class="lineNum">     497 </span>            : #undef QT_FORWARD_DECLARE_MUTABLE_CF_TYPE</a>
<a name="498"><span class="lineNum">     498 </span>            : #undef QT_FORWARD_DECLARE_CG_TYPE</a>
<a name="499"><span class="lineNum">     499 </span>            : #undef QT_FORWARD_DECLARE_MUTABLE_CG_TYPE</a>
<a name="500"><span class="lineNum">     500 </span>            : </a>
<a name="501"><span class="lineNum">     501 </span>            : #endif // Q_OS_MAC</a>
<a name="502"><span class="lineNum">     502 </span>            : </a>
<a name="503"><span class="lineNum">     503 </span>            : QT_END_NAMESPACE</a>
<a name="504"><span class="lineNum">     504 </span>            : </a>
<a name="505"><span class="lineNum">     505 </span>            : #endif // QDEBUG_H</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
